#-*- coding: utf-8 -*-
#   ____ ___  _   ___   ____  __
#  / ___/ _ \| \ | \ \ / /\ \/ /
# | |  | | | |  \| |\ V /  \  /
# | |__| |_| | |\  | | |   /  \
#  \____\___/|_| \_| |_|  /_/\_\
#
# Console Nyx Client
#
# Conyx Operations Library
#
# version 0.2.3
#
# You can do whatever You want with Conyx.
# But I don't take reponsbility nor even
# implied responsibility for the harm,
# damage, loss or anything negative
# You cause using Conyx.
#
# There is no service provided. The program
# is AS-IS and there is ABSOLUTELY no warranty
# provided.
#

import sys, os, traceback
if ('CONYX') in os.environ:
  sys.path.insert(0, (os.environ['CONYX']+'/lib'))
from nyxOp import nyx_show_disc_msgs, nyx_show_disc_msgs_filter, nyx_show_disc_msgs_from
from nyxMail import * 
from conyxDBQuery import conyxDBQuery
from conyxDBGenDML import conyxDBGenDML
from conyxDBGenDMLVars import conyxDBGenDMLVars
from conyxDBUpdNickname import conyxDBUpdNickname
#from tuiFile import *
from tuiBuffer import tuiScrollContent
import locale

def cacheVypisPrispevky():
  cols,rows=conyxDBQuery("select id_prispevek, prisp_from ||'|'||prisp_text||'|'||prisp_hodnoceni from prispevek_cache")
  return(cols,rows)

def getKlubNameFromID(id_klub):
  cols,rows=conyxDBQuery("select jmeno from klub_cache where id_klub = '" + str(id_klub)+"'")
  return(rows[0][0])

def ctiKlub(klub_id):
  print("Nacitam klub do databaze " + str(klub_id))
  try:
    buf=nyx_show_disc_msgs(str(klub_id))
    conyxDBGenDML('update klub_cache set unread = "0" where id_klub="'+str(klub_id)+'"')
    #cacheVypisPrispevky()
  except Exception:
    traceback.print_exc(file=sys.stdout)
    print("Nepodarilo se ulozit prispevky z aktualni diskuze do databaze")

def cleanHtml(text):
  cleanr = re.compile('<.*?>')
  cleantext = re.sub(cleanr,'', text)
  cleantext=cleantext.replace('\n','')
  cleantext=cleantext.replace('\r','')
  return cleantext

def conyxOpsTuiBuffer(name,buff,klub_unread=0):
  locale.setlocale(locale.LC_ALL, '')
  tuiScrollContent(name,buff,klub_unread)

def zobrazDiskuzi(klub_id,screen,onTerm=0,id_wu=None,dir="older_than",filter_user=None,filter_keyword=None):
  #print("Nacitam klub do databaze " + str(i_klub_id))
  try:
    if not (filter_user is None):
      buf=nyx_show_disc_msgs_filter(str(klub_id),filter_user,None)
    elif not (filter_keyword is None):
      buf=nyx_show_disc_msgs_filter(str(klub_id),None,filter_keyword)
    elif not (id_wu is None):
      buf=nyx_show_disc_msgs_from(str(klub_id),id_wu,dir)
    else:
      buf=nyx_show_disc_msgs(str(klub_id))
    #print("posledni prispevek: " + str(int(res[1][0][0])))
    qry='select unread from klub_cache where id_klub = ?'
    cols, rows = conyxDBQuery(qry,(klub_id,))
    klub_unread=0
    if len(rows)>0:
      klub_unread=rows[0]
      if len(klub_unread)>0:
        klub_unread=klub_unread[0]
    conyxDBGenDML('update klub_cache set unread = "0" where id_klub="'+str(klub_id)+'"')
  except Exception:
    traceback.print_exc(file=sys.stdout)
    print("Nepodarilo se ulozit prispevky z aktualni diskuze do databaze")
    input("PROBLEM")
  #
  #buf=nyx_show_disc_msgs(str(klub_id))
  #screen.addstr(0,0,str(klub_unread))
  #screen.refresh()
  #screen.getch()
  qry='select prisp_from || "|" ||replace(prisp_text,"|",char(1)) || "|" ||  prisp_hodnoceni wu_rating from prispevek_cache where id = ? order by id_prispevek asc'
  cols, rows = conyxDBQuery(qry,(klub_id,))
  #cols, rows = conyxDBQuery('select prisp_from || "|"||id_prispevek||"."||prisp_text || "|" ||  prisp_hodnoceni wu_rating from prispevek_cache')
  buff=[]
  for i in rows:
    buff.append(i[0])
  #f=open("debug.txt","w")
  #f.write(str(buff))
  #f.close()
  #f=open("debug.txt","r")
  #data = f.read()
  #f.close()
  #lines = data.splitlines()
  ##lines=data
  ##print(lines[0])
  #from bs4 import BeautifulSoup
  #soup = BeautifulSoup(buff, "html.parser")
  #image_url=""
  #for img in soup.findAll('img'):
  #  #print(img['data-thumb'])
  #  image_url=img['data-thumb']
  #  from lib.img2ans import get_img_from_url
  #  ret = get_img_from_url(image_url)
  #  print(ret)
  #  print("Loaded")
  #  break
  #import requests
  #img_data = requests.get(image_url).content
  #with open('tmp.jpg', 'wb') as handler:
  #    handler.write(img_data)
  #from lib.c_image import image_to_display
  #image_to_display("tmp.jpg")
  #screen.getch()
  if rows:
    if onTerm==0:
      print(rows)
      print(len(rows))
    if len(rows[0])>0:
      #klub_name=getKlubNameFromID(klub_id)[:width-10]
      klub_name=""
      try:
        klub_name=getKlubNameFromID(klub_id)[:-10]
      except Exception:
        1==1
      conyxOpsTuiBuffer(klub_name,buff,klub_unread)
  else:
    screen.clear()
    screen.refresh()
    screen.addstr(1,3,"Nic nenalezeno...")
    screen.getch()
  screen.clear()
  screen.refresh()

#print(getKlubNameFromID(3))
