# encoding=utf-8
#   ____ ___  _   ___   ____  __
#  / ___/ _ \| \ | \ \ / /\ \/ /
# | |  | | | |  \| |\ V /  \  /
# | |__| |_| | |\  | | |   /  \
#  \____\___/|_| \_| |_|  /_/\_\
#
# Console Nyx Client
#
# Conyx Text User Interface Main Menu Library
#
# version 0.2.8
#
# I do not take reponsbility nor even implied 
# responsibility for the harm, damage, loss 
# or anything negative You cause using Conyx.
#
# There is no service provided. The program
# is AS-IS and there is ABSOLUTELY no warranty
# provided.
#

DEBUG=0

import curses
from math import *

actual_char='='
  
import sys, os, traceback
import locale
import sys
import re
import time

from curses.textpad import Textbox, rectangle

if ('CONYX') in os.environ:
  sys.path.insert(0, (os.environ['CONYX']+'/lib'))
from conyxDBQuery import conyxDBQuery
from nyxMail import nyx_list_mail, nyx_send_mail, nyx_filter_mail
from tuiBuffer import cleanHtml, br2nl
from sutf8 import sutf8 
from inputBox import inputBox
from ugetch import ugetch
from py_curses_lib import init_colors

def mailPrepareText(text,width,height):
  orig_text=text
  tmp=orig_text.strip().split('\n')
  text=""
  # b lib/tuiMai.py:50
  for i in tmp:
    text+=i
    if (len(i)!=width-4):
      text+='\n'
  return(text)

#def getCurrentMsgId(strings,position):
#  msg_id=strings[position-1].split('|')[0]
#  return(msg_id)

def displayMail(screen,strings,position,width,height,msg_ids):
   if position>len(strings)-2:
     return
   screen.clear()
   #msg_id=strings[position-1].split('|')[0]
   #msg_id=msg_ids[position]
   msg_id=msg_ids[position].split('|')[0]
   msg_content=getMailContent(msg_id)
   msg_date=time.strftime("%d.%m.%Y %H:%M",time.localtime(int(msg_content[0][2]))) 
   screen.addstr(0,0,"-|"+("-"*(width-5))+"|-")
   msg_str_dir="Od: "
   msg_str_act="Prijato:  "
   #if (msg_content[0][3]=='to'):
   if (msg_content[0][3]=='O'):
     msg_str_dir="Komu: "
     msg_str_act="Odeslano: "
   if DEBUG == 1:
     msg_str_dir=msg_str_dir+msg_id+" "+str(position)
   msg_str_dir=msg_str_dir
   screen.addstr(1,2,msg_str_dir+str(msg_content[0][0]) + "")
   screen.addstr(1,width-29,msg_str_act+str(msg_date)+ "")
   screen.addstr(2,0,"-|"+("-"*(width-5))+"|-")
   #screen.addstr(height-1,1,"-|"+("-"*(width-14))+" "+(str(position)+"/"+str(len(strings))).ljust(6)+" |-")
   footer_help="| o - odpovez, h,l - pohyb, q - zpet |"
   #if DEBUG==1:
   #  ptrstr=i-((height-1)*(page-1))+position
   #footer_help+=str(position)+" "+str(page-1)+" "+str(ptrstr)
   #else:
   #footER="-"+footer_help+("-"*(width-len(footer_help)-15))+"| "+(str(position)+"/"+str(len(strings))).ljust(6)+" |-"
   #footER="-"+footer_help+("-"*(width-len(footer_help)-15))+"| "+(str(position)+"/"+str(len(strings))).ljust(6)+" |-"
   screen.addstr(height-1,1,footer_help)
   try:
     screen.addstr(4,0,br2nl(msg_content[0][1])+ "")
   except Exception as e:
     screen.addstr(height-1,4,'Nedari se mi korektne zobrazit zpravu')

def getMailContent(msg_id):
  buffer=[]
  #print("MSG ID: "+msg_id)
  cols, rows = conyxDBQuery("select other_nick, content, time, direction from mail where id = %s" % (msg_id))
  for i in rows:
    #print(str(i[0])+" "+str(i[1])+" "+str(i[2])+" "+str(i[3]))
    buffer.append((str(i[0]),str(i[1]),str(i[2]),str(i[3])))
  return (buffer)

def getMail(height=20,screen=None,filter_from=""):
  height,width=screen.getmaxyx()
  xrows=height-1
  buff=[]
  msg_ids=[]
  qry=""
  if filter_from != "":
    #qry = f"select id, direction, other_nick, time from mail where other_nick = {filter_from} order by id desc"
    #qry = f"select id, direction, other_nick, time from mail where other_nick = '%%' order by id desc"
    qry = f"select id, direction, other_nick, time, content from mail where lower(other_nick) like lower('%{filter_from[:-1]}%') order by id desc"
    #print(qry)
  else:
    qry = "select id, direction, other_nick, time, content from mail order by id desc"
  cols, rows = conyxDBQuery(qry)
  for i in rows:
    msg_date=time.strftime("%d.%m.%Y %H:%M", time.localtime(int(i[3])))
    msg_dir='od: '
    msg_sym='<'
    m_msg_id=str(i[0])
    #rol=width-9-(len(msg_date)+len(str(i[2]))) # rest of line
    txtmsg=str(cleanHtml(i[4].replace('\n','')))
    #if xljust < 0: xljust = width-1
    rol=width-9-(len(msg_date)+len(str(i[2]))) # rest of line
    xljust=width-len(msg_date)
    if (i[1]=='O'):
      msg_dir=  'komu: '
      msg_sym=  '>'
    txtprn=(msg_sym+'['+msg_date+']['+(str(i[2]))+": "+(txtmsg[:rol])).ljust(width-3)+"]"
    buff.append(txtprn)
    msg_ids.append(str(i[0]))
  return (buff,msg_ids)

def tuiMail(screen=None):
  #screen = curses.initscr()
  global cols
  txt_msg_filter=""
  height,width=screen.getmaxyx()
  msgDisplayed=0
  tmp=[] 
  strings=[] 
  #cols, rows = conyxDBQuery("select 9000000 nid from mail")
  #nyx_list_mail(adel=True,page="next",from_id="90000000000")
  #nyx_list_mail(adel=False)
  nyx_list_mail(adel=False)
  #for i in range(3):
  tmp,msg_ids=getMail(screen=screen)
  #nyx_list_mail(adel=False,page="next",from_id=str(msg_ids[-1]))
  #tmp,msg_ids=getMail()
  
  #nyx_list_mail(adel=False,page="next",from_id=str(msg_ids[0]))
  #nyx_list_mail(page="next",from_id=msg_ids[-1])
  #tmp,msg_ids=getMail(height)
  #row_num = len(strings)
  row_num = height
  strings=tmp
  curses.noecho()
  curses.cbreak()
  #curses.start_color()
  screen.keypad(1)
  cols=init_colors()
  #curses.init_pair(1,curses.COLOR_BLACK,curses.COLOR_CYAN)
  #highlightText=curses.color_pair(1)
  #normalText=curses.A_NORMAL

  max_row=height-1

  box=curses.newwin(max_row+2,width,0,0)

  pages=int(ceil(row_num/max_row))
  last_pos=0
  last_page=1
  position=last_pos 
  page=last_page

  #height,width=screen.getmaxyx()
  #for i in range(0,height-1):
  #  ptrstr=i-((height-1)*(page-1))+position
  #  if ptrstr<len(strings):
  #    if i==position:
  #      box.addstr(i,0,actual_char+strings[ptrstr],cols["hiTe"])
  #    else:
  #      box.addstr(i,0," "+strings[ptrstr],cols["loWh"])
  #for i in range(0,height-1): # max_row*(page-1),(max_row*(page-1)+max_row)):
  #  #pline=i
  #  #sidx=((page-1)*(height-1))+i-1
  #  #if sidx < len(strings):
  #  box.addstr(i,0,"["+str(i)+"]"+" ["+str(height)+"]", highlightText)
  #  #box.addstr(pline,0,actual_char+" "+cleanHtml(sutf8(strings[sidx])), highlightText)
  #  #pline=pline+1
  #  #if pline > 20:
  #  #  break
  #  #else:
  #  #  #box.addstr(i-(max_row*(page-1)),0,"  "+cleanHtml(sutf8(strings[i-1])),normalText)
  #  #  box.addstr(i-(max_row*(page-1)),0,"  "+cleanHtml(sutf8(strings[i-1])),normalText)
  #  #if i >= (height-1):
  #  #  break
  #tmp,msg_ids=getMail()
  #box.addstr(20+1,1,str(strings[-1][1][:16]))
  # HERE FOOTER COMMENT
  #mm_footer_help="-=[ pohyb: j,k,n,u,ENTER ]=-" 
  #if DEBUG==1:
  #  ptrstr=i-((height-1)*(page-1))+position
  #  mm_footer_help+=" P: "+str(position)+" PA: "+str(page-1)+" PS: "+str(ptrstr)+" MI: "+msg_ids[ptrstr]
  #box.addstr(height-1,0,mm_footer_help,cols["loWh"])
  # HERE FOOTER COMMENT
  #screen.refresh()
  #box.refresh()
  tuiMailDisplayed=0
  #x = screen.getch()
  #while x != 113 and tuiMailDisplayed>=0: # dokud neni stisknuta klavesa 'q'
  x=ord('=')
  last_download=" žádný"
  while tuiMailDisplayed>=0: # dokud neni stisknuta klavesa 'q'
    height, width = screen.getmaxyx()
    #screen.move(0,width-1)
    if (tuiMailDisplayed==0):
      #if x==curses.PG_DOWN or x==ord('n'):
      if x==ord('c'): # clear cache
        nyx_list_mail(adel=False)
      elif x==curses.KEY_END:
        #cols, rows = conyxDBQuery("select max(id) from mail")
        #page=page-1
        page=int(len(strings)/(height-2))
      elif (tuiMailDisplayed==0 and x==curses.KEY_LEFT) or x==ord('u') or x==curses.KEY_PPAGE:
        if page>1:
          page=page-1
        else:
          position=0
        #position=width-2
        #screen.clear()
        #screen.refresh()
        #box.clear()
        #box.refresh()
      elif x==curses.KEY_RIGHT or x==ord('n') or x==curses.KEY_NPAGE:
        ptrstr=height*page
        if ptrstr>len(strings)-height-2:
          tmp,msg_ids=getMail(screen=screen)
          nyx_list_mail(adel=False,page="next",from_id=str(msg_ids[-1]))
          tmp,msg_ids=getMail(screen=screen)
          nyx_list_mail(adel=False,page="next",from_id=str(msg_ids[-1]))
          tmp,msg_ids=getMail(screen=screen)
        page=page+1
        #position=0
        #screen.clear()
        #screen.refresh()
        #box.clear()
        #box.refresh()
        #ptrstr=((height-1)*(page-1))+position
        #if msg_ids[-height-3]>str(ptrstr):
        #  for i in range(3):
        #    tmp,msg_ids=getMail()
        #    nyx_list_mail(adel=False,page="next",from_id=str(msg_ids[-1]))
      elif x==curses.KEY_DOWN or x==ord('j'):
         #if page==1:
         #if position<height-1:
         if position<height-2:
           position=position+1
         #position = ( 1 + ( max_row * ( page - 1 ) ) )
         #  #if page==1:
         #  if position<i:
         #    position=position+1
         #  else:
         #    if pages>1:
         #      page=page+1
         #      position=1+(max_row*(page-1))
         #elif page==pages:
         #  if position<row_num:
         #    position=position+1
         #else:
         #  if position<max_row+(max_row*(page-1)):
         #    position=position+1
         #  else:
         #    max_msg_id=msg_ids[len(msg_ids)-1]
         #    #nyx_list_mail(page="next",from_id=max_msg_id) # HERE
         #    page=page+1
         #    #position=1+(max_row*(page-1))
         #    position=1
      #elif x == ord("n"):
      elif x==ord('g'):
        screen.clear() 
        screen.refresh()
        curses.cbreak()
        screen.addstr(1,3,"Jdi na stranu: [ ctrl+g pro odeslani ]")
        x=4;y=4;h=1;w=25
        rectangle(screen,x-1,y-1,h+x+1,w+y+1)
        editwin = curses.newwin(h,w,x,y)
        screen.refresh()
        searchBox=inputBox(editwin)
        searchBox.edit()
        try:
          page=int(searchBox.gather())
        except:
          pass
      elif x == ord('s'): # SEARCH
        screen.clear() 
        screen.refresh()
        curses.cbreak()
        screen.addstr(1,3,"Vyhledat dopisy od: [ ctrl+g pro odeslani ]")
        x=4;y=4;h=1;w=25
        rectangle(screen,x-1,y-1,h+x+1,w+y+1)
        editwin = curses.newwin(h,w,x,y)
        screen.refresh()
        searchBox=inputBox(editwin)
        searchBox.edit()
        txt_msg_search=searchBox.gather()
      elif x == ord('f'): # FROM
        screen.clear() 
        screen.refresh()
        curses.cbreak()
        screen.addstr(1,3,"Vyhledat dopisy od: [ ctrl+g pro odeslani ]")
        x=4;y=4;h=1;w=25
        rectangle(screen,x-1,y-1,h+x+1,w+y+1)
        editwin = curses.newwin(h,w,x,y)
        screen.refresh()
        searchBox=inputBox(editwin)
        searchBox.edit()
        txt_msg_filter=searchBox.gather()
        if (txt_msg_filter!=""):
          #nyx_filter_mail(text,"")
          tmp,msg_ids=getMail(screen=screen,filter_from=txt_msg_filter)
          row_num = len(strings)
          strings=tmp
      elif x == curses.KEY_UP or x == ord('k'):
        #if page == 1:
        if position>0:
          position = position - 1
        #else:
        #    if position>(1 + (max_row*(page-1))):
        #      position = position - 1
        #    else:
        #      page=page-1
        #      position=max_row+(max_row*(page-1))
      #elif x == curses.KEY_LEFT or x == ord('h'):
      #  if page > 1:
      #     page=page-1
      #     position=1+(max_row*(page-1))
      #elif x == curses.KEY_RIGHT or x == ord('l'):
      #  if page < pages:
      #     page = page + 1
      #     position = ( 1 + ( max_row * ( page - 1 ) ) )
      elif x == ord('\n') and position >= 0:
        #displayMail(screen,strings,((page-1)*max_row)+position,width,height,msg_ids)
        ptrstr=((height-1)*(page-1))+position
        displayMail(screen,strings,ptrstr,width,height,msg_ids)
        tuiMailDisplayed=1
    # DISPLAYED MAIL DETAIL
    if tuiMailDisplayed==1:
      if x in (curses.KEY_RIGHT,ord('l')):
        if position<len(strings):
          position+=1
        displayMail(screen,strings,position,width,height,msg_ids)
      elif x in (curses.KEY_LEFT,ord('h')):
        if position>0:
          position-=1
        displayMail(screen,strings,position,width,height,msg_ids)
      elif x == ord('o'): # O - odpovez
        screen.clear()
        screen.refresh()
        curses.cbreak()
        #msg_id=getCurrentMsgId(msg_ids,position)
        #msg_id=msg_ids[position-1].split('|')[0]
        #msg_id=msg_ids[((height-1)*(page-1))+position]
        msg_id=msg_ids[((height-1)*(page-1))+position]
        msg_content=getMailContent(msg_id)
        msg_recepient=msg_content[0][0]
        screen.addstr(0,2,"Zadej zpravu pro " + msg_recepient + ":")
        #footer="pos " + str(position) + " page " + str(page) + " mr " + str(max_row) + " row_num " + str(row_num) + " | -=[ ctlr+G - posli, ctrl+X - zrus ]=-"
        footer="-=[ ctlr+G - posli, ctrl+X - zrus ]=-"
        screen.addstr(height-1,0,footer)
        #height, width = screen.getmaxyx()
        x=2;y=2;h=height-y;w=width-x;
        rectangle(screen,y-1,x-1,h,w)
        editwin = curses.newwin(h-2,w-2,y,x)
        screen.refresh()
        quo_text = msg_content
        mailBox=inputBox(editwin,quo_text)
        text=mailBox.edit()
        curses.nocbreak()
        if (text!=""): 
          #text=cleanHtml(text)
          text=mailPrepareText(text,width,height)
          if (nyx_send_mail(msg_recepient,text)==0):
            screen.addstr(0, 0, " "*width)
            screen.addstr(0, 0, "Dopis pro "+msg_recepient+" odeslán.")
          else:
            screen.addstr(0, 0, " "*width)
            screen.addstr(0, 0, "Nastala chyba při odesílání dopisu.")
          screen.refresh()
          curses.cbreak()
          box.getch()
          screen.clear()
          screen.refresh()
        else:
          screen.addstr(0, 0, " "*width)
          screen.addstr(0, 2, "Zpráva zrušena, stiskni libovolnou klávesu.")
          screen.refresh()
          curses.cbreak()
          box.getch()
          screen.clear()
          screen.refresh()
        curses.cbreak()
        tuiMailDisplayed=0
        # nyx_list_mail() # HERE
        #screen.refresh()
        #screen.clear()
        #tmp=getMail(screen=screen)
        tmp,msg_ids=getMail(screen=screen,filter_from=txt_msg_filter)
        strings=tmp
        row_num=len(strings)
    if x==ord('q') or (tuiMailDisplayed==1 and x==curses.KEY_LEFT):
      if tuiMailDisplayed==0:
        break
      elif tuiMailDisplayed==1:
        tuiMailDisplayed=0
        #screen.clear()
        #screen.refresh()
        #box.clear()
        #box.refresh()
        screen.clear()
        screen.refresh()
    # list of messages
    if tuiMailDisplayed==0:
      #box.clear()
      #box.refresh()
      #tmp,msg_ids=getMail(screen=screen)
      tmp,msg_ids=getMail(screen=screen,filter_from=txt_msg_filter)
      #height,width=screen.getmaxyx()
      strings=tmp
      #for i in range(1,len(strings)):
      for i in range(0,height-1):
        pgshift=(height-1)*(page-1)
        ptrstr=pgshift+i
        if ptrstr<len(strings):
          if i==position:
            box.addstr(i,0,actual_char+strings[ptrstr][:width-2],cols["hiTe"])
          else:
            box.addstr(i,0," "+strings[ptrstr][:width-2],cols["loWh"])

    # print help
    mm_footer_help="-=[ pohyb: j,k,n,u,g,ENTER ]=-" 
    if DEBUG==1:
      ptrstr=((height-1)*(page-1))+position
      mm_footer_help+=" P: "+str(position)+" PA: "+str(page-1)+" PS: "+str(ptrstr)+" MI: "+msg_ids[ptrstr]
    box.addstr(height-1,0,mm_footer_help,cols["loWh"])
    #txt_pg="Přip.:"+str(last_download)+" Řád.: "+str(position)+" Str. "+str(page)
    txt_pg="[ Řád.: "+str(position)+" Str. "+str(page)+" ]"
    box.addstr(height-1,width-len(txt_pg)-1,txt_pg,cols["loWh"])
    # end of page reload
    screen.move(0,width-1)
    box.refresh()
    screen.refresh()
    x = screen.getch()
  screen.clear()

